/** -*- c++ -*- **************************************************************
 **
 ** Copyright 2014 Lynx Technik AG (www.lynx-technik.com)
 **
 ** Licensed under the Apache License, Version 2.0 (the "License");
 ** you may not use this file except in compliance with the License.
 ** You may obtain a copy of the License at
 **
 ** http://www.apache.org/licenses/LICENSE-2.0
 **
 ** Unless required by applicable law or agreed to in writing, software
 ** distributed under the License is distributed on an "AS IS" BASIS,
 ** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ** See the License for the specific language governing permissions and
 ** limitations under the License.
 *****************************************************************************/

#ifndef ADAPTER_XILINX_PAR_H
#define ADAPTER_XILINX_PAR_H

#include "jtagAdapter.h"

class parallelPort;

class AdapterXilinx_par : public jtagAdapter
{
    friend class AdapterManager;
private:
    int usdelay;
    unsigned char portval;
    parallelPort *par;

    enum PINS
    {
        _TDI = 0, // D0      (data port)
        _TCK = 1, // D1      (data port)
        _TMS = 2, // D2      (data port)
        _CTRL= 3, // D3      (data port)
        _PROG= 4, // D4      (data port)
        _WE  = 5, // D5      (data port)

        _TDO = 4, // #SELECT (status port)
        _PWR = 3, //         (status port)
    };

    void out(unsigned char val);
    char in();

public:
    AdapterXilinx_par ();
    ~AdapterXilinx_par ();

    void setJTAGSpeed(int Hz);
    int  init();
    void release(bool bFullRelease = false);

    void setTCK(int val);
    void setTMS(int val);
    void setTDI(int val);
    int  getTDO();
	void clock(int val);
	void doState(int val);
	int  shift(int shiftState, struct shiftData *dat, int endState, bitvector *readback);
};

#endif // ADAPTER_XILINX_PAR_H
