/** -*- c++ -*- **************************************************************
 **
 ** Copyright 2014 Lynx Technik AG (www.lynx-technik.com)
 **
 ** Licensed under the Apache License, Version 2.0 (the "License");
 ** you may not use this file except in compliance with the License.
 ** You may obtain a copy of the License at
 **
 ** http://www.apache.org/licenses/LICENSE-2.0
 **
 ** Unless required by applicable law or agreed to in writing, software
 ** distributed under the License is distributed on an "AS IS" BASIS,
 ** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ** See the License for the specific language governing permissions and
 ** limitations under the License.
 *****************************************************************************/

#ifndef BITVECTOR_H
#define BITVECTOR_H

#include <string>
#include <vector>
#include <stdint.h>
using namespace std;

class bitvector : public std::vector<bool>
{
	public:
	enum { BINARY, HEXADECIMAL };

	void append(bitvector &add);
	int push_back_nibble(const char ch);
	int push_back_string(const char *ch);
	int push_back_value (const uint32_t val);
	int push_back_value (const uint64_t val, int len);
	int push_back_buffer(const unsigned size, const unsigned char *poi);
	string toString (int format);
	uint32_t toNum();
};

#endif // BITVECTOR_H
