/** -*- c++ -*- **************************************************************
 **
 ** Copyright 2014 Lynx Technik AG (www.lynx-technik.com)
 **
 ** Licensed under the Apache License, Version 2.0 (the "License");
 ** you may not use this file except in compliance with the License.
 ** You may obtain a copy of the License at
 **
 ** http://www.apache.org/licenses/LICENSE-2.0
 **
 ** Unless required by applicable law or agreed to in writing, software
 ** distributed under the License is distributed on an "AS IS" BASIS,
 ** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ** See the License for the specific language governing permissions and
 ** limitations under the License.
 *****************************************************************************/

#include <string>
#include <stdarg.h>
#include <iostream>
#include "jtagAdapter.h"
#include <pthread.h>

using namespace std;

jtagAdapter::jtagAdapter()
{
    curState  = FAIL;

    chain.instBefore  = 0;
    chain.instAfter   = 0;
    chain.devBefore   = 0;
    chain.devAfter    = 0;
}

void jtagAdapter::setChain(struct jtagDaisyInfo chain)
{
    this->chain = chain;
}

int jtagAdapter::checkReadbackData (unsigned len, bitvector *tdo, bitvector *readback, bitvector *mask)
{
    unsigned i, failed = 0;

    if (readback->size() < len)
    {
        failed = 1;
        len = 0;
    }

    for (i=0; i<len; i++)
        if ( (mask->size() == 0) || (mask->at(mask->size()-i-1)) )
        {
            if ( ((int)tdo->at(tdo->size()-i-1)) != ((int)(*readback)[i]) )
            {
                failed = 2;
                break;
            }
        }

    if (failed)
        return 1;

    return 0;
}

void jtagAdapter::runtest(int val, float minTime, float maxTime)
{
	clock(val);
}

